'use strict';

var React = require('react');
var classNames = require('classnames');
var Icon = require('@adrianjiang/tiny-icons');
var Input = require('@adrianjiang/rc-input');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);
var Icon__default = /*#__PURE__*/_interopDefaultLegacy(Icon);
var Input__default = /*#__PURE__*/_interopDefaultLegacy(Input);

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = ".rc-input-search {\n  width: 280px;\n  overflow: hidden;\n  border-radius: 37px;\n  transition: all 218ms;\n  height: 32px;\n  margin: auto;\n  background-color: #f7f7f7;\n  position: relative;\n  font-size: 14px;\n  line-height: 20px;\n}\n.rc-input-search .tiny-input {\n  border: none;\n  outline: none;\n  background: transparent;\n  font-size: 14px;\n  height: 32px;\n  line-height: 20px;\n  border-radius: 3px;\n  padding: 6px 12px 6px 40px;\n  display: block;\n  opacity: 1;\n  width: 280px;\n  position: relative;\n  z-index: 1;\n}\n.rc-input-search .tiny-input-affix-wrapper {\n  border: none;\n  outline: none;\n  background: transparent;\n  padding: 3px 12px 3px 40px;\n}\n.rc-input-search-mask {\n  position: absolute;\n  max-width: 200px;\n  width: auto;\n  height: 20px;\n  top: 6px;\n  left: 0;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n      -ms-user-select: none;\n          user-select: none;\n  transform: translateX(calc(140px - 50%)) translateZ(0);\n  transition-property: transform;\n  transition-duration: 168ms;\n  transition-timing-function: ease-in-out;\n  box-sizing: border-box;\n  cursor: text;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  color: #9c9c9c;\n}\n.rc-input-search-mask-focus {\n  transform: translateX(14px) translateZ(0);\n}\n.rc-input-search-mask .tiny-icon {\n  margin-right: 8px;\n}\n";
styleInject(css_248z);

var SearchInput = function SearchInput(props) {
  var _useState = React.useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      focus = _useState2[0],
      setFocus = _useState2[1];

  var _useState3 = React.useState(true),
      _useState4 = _slicedToArray(_useState3, 2),
      placeholderStatus = _useState4[0],
      setPlaceholderStatus = _useState4[1];

  return /*#__PURE__*/React__default['default'].createElement("div", {
    className: 'rc-input-search'
  }, /*#__PURE__*/React__default['default'].createElement(Input__default['default'], {
    defaultValue: props.defaultValue,
    value: props.value,
    allowClear: props.allowClear,
    onFocus: function onFocus(event) {
      setFocus(true);
      props.onFocus !== undefined && props.onFocus(event);
    },
    onBlur: function onBlur(event) {
      setFocus(false);
      props.onBlur !== undefined && props.onBlur(event);
    },
    onChange: function onChange(event) {
      setPlaceholderStatus(!Boolean(event.target.value));
      props.onChange !== undefined && props.onChange(event);
    },
    onPressEnter: function onPressEnter(event) {
      event.persist();
      props.onPressEnter !== undefined && props.onPressEnter(event);
    }
  }), /*#__PURE__*/React__default['default'].createElement("div", {
    className: classNames__default['default']({
      'rc-input-search-mask': true,
      'rc-input-search-mask-focus': focus || !placeholderStatus
    })
  }, /*#__PURE__*/React__default['default'].createElement(Icon__default['default'], {
    type: "search",
    style: {
      fontSize: 20
    }
  }), /*#__PURE__*/React__default['default'].createElement("span", {
    className: 'rc-input-search-mask-text'
  }, placeholderStatus && props.placeholder)));
};

SearchInput.defaultProps = {
  placeholder: '搜索'
};

module.exports = SearchInput;
